## ignition-transport10 10.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-transport10 VERSION 10.1.0)

#============================================================================
# Find ignition-cmake
#============================================================================
# If you get an error at this line, you need to install ignition-cmake
find_package(ignition-cmake2 2.8.0 REQUIRED)
set(IGN_CMAKE_VER ${ignition-cmake2_VERSION_MAJOR})

#============================================================================
# Configure the project
#============================================================================
ign_configure_project(VERSION_SUFFIX)

#============================================================================
# Set project-specific options
#============================================================================

# ignition-transport currently has no options that are unique to it

if (UNIX AND NOT APPLE)
  set (EXTRA_TEST_LIB_DEPS stdc++fs)
else()
  set (EXTRA_TEST_LIB_DEPS)
endif()

#============================================================================
# Search for project-specific dependencies
#============================================================================
message(STATUS "\n\n-- ====== Finding Dependencies ======")

#--------------------------------------
# Find Protobuf
set(REQ_PROTOBUF_VER 3)
ign_find_package(IgnProtobuf
                 VERSION ${REQ_PROTOBUF_VER}
                 REQUIRED
                 PRETTY Protobuf)

#--------------------------------------
# Find ZeroMQ
ign_find_package(ZeroMQ VERSION 4 REQUIRED PRIVATE)

if (UNIX AND NOT APPLE)
  execute_process(COMMAND lsb_release -cs
    OUTPUT_VARIABLE RELEASE_CODENAME
    RESULT_VARIABLE LSB_RESULT
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  if( NOT (${LSB_RESULT} STREQUAL "0"))
    message(WARNING "lsb_release executable not found. Disabling focal-specific workarounds")
  elseif (${RELEASE_CODENAME} STREQUAL "focal")
    set(UBUNTU_FOCAL 1)
  endif()
endif()

#--------------------------------------
# Find cppzmq
ign_find_package(CPPZMQ REQUIRED PRIVATE
  PKGCONFIG_IGNORE # NOTE: cppzmq does not seem to offer a pkg-config file
  PRETTY CppZMQ)

#--------------------------------------
# Find uuid
if (MSVC)
  message (STATUS "UUID: Using Windows RPC UuidCreate function\n")
else()
  ign_find_package(UUID REQUIRED)
endif()

#--------------------------------------
# Find ignition-utils
ign_find_package(ignition-utils1 REQUIRED COMPONENTS cli)
set(IGN_UTILS_VER ${ignition-utils1_VERSION_MAJOR})

#--------------------------------------
# Find ignition-msgs
ign_find_package(ignition-msgs7 REQUIRED)
set(IGN_MSGS_VER ${ignition-msgs7_VERSION_MAJOR})

#--------------------------------------
# Find ifaddrs
ign_find_package(IFADDRS QUIET)
if (IFADDRS_FOUND)
  set (HAVE_IFADDRS ON CACHE BOOL "HAVE IFADDRS" FORCE)
else ()
  set (HAVE_IFADDRS OFF CACHE BOOL "HAVE IFADDRS" FORCE)
endif()

#--------------------------------------
# Find ignition-tools
ign_find_package(ignition-tools QUIET)

#--------------------------------------
# Find SQLite3
ign_find_package(SQLite3
  VERSION 3.7.13
  REQUIRED_BY log
  PRIVATE_FOR log
  PRETTY sqlite3)


#============================================================================
# Configure the build
#============================================================================
ign_configure_build(QUIT_IF_BUILD_ERRORS
  COMPONENTS log)

#============================================================================
# ign command line support
#============================================================================
add_subdirectory(conf)

#============================================================================
# Create package information
#============================================================================
ign_create_packages()

#============================================================================
# Configure documentation
#============================================================================
configure_file(${CMAKE_SOURCE_DIR}/api.md.in ${CMAKE_BINARY_DIR}/api.md)
configure_file(${CMAKE_SOURCE_DIR}/tutorials.md.in ${CMAKE_BINARY_DIR}/tutorials.md)

ign_create_docs(
  API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
  TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md")

=== example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

project(ignition-transport-examples)

# Find the Ignition_Transport library
find_package(ignition-transport10 QUIET REQUIRED OPTIONAL_COMPONENTS log)
set(IGN_TRANSPORT_VER ${ignition-transport10_VERSION_MAJOR})

if (EXISTS "${CMAKE_SOURCE_DIR}/msgs/")
  # Message generation. Only required when using custom Protobuf messages.
  find_package(Protobuf REQUIRED)
  add_subdirectory(msgs)
  set_source_files_properties(${PROTO_SRC} ${PROTO_HEADER} PROPERTIES GENERATED TRUE)
endif()

include_directories(${CMAKE_BINARY_DIR})

# Generate examples
if (EXISTS "${CMAKE_SOURCE_DIR}/bench.cc")
  ########################################
  # GFlags
  find_library(gflags_LIBRARIES NAMES gflags)
  find_path(gflags_INCLUDE_DIRS gflags/gflags.h ENV CPATH)
  if (NOT gflags_LIBRARIES OR NOT gflags_INCLUDE_DIRS)
    message (STATUS "Unable to compile 'bench.cc', missing GFLags library")
  else()
    include_directories(SYSTEM ${gflags_INCLUDE_DIRS})
    add_executable(bench bench.cc)
    target_link_libraries(bench
      ignition-transport${IGN_TRANSPORT_VER}::core
      ${gflags_LIBRARIES}
      pthread)
  endif()
endif()

if (NOT MSVC AND EXISTS "${CMAKE_SOURCE_DIR}/publisher_c.cc")
  add_executable(publisher_c publisher_c.cc)
  target_link_libraries(publisher_c ignition-transport${IGN_TRANSPORT_VER}::core)
endif()
if (NOT MSVC AND EXISTS "${CMAKE_SOURCE_DIR}/publisher_c_fast.cc")
  add_executable(publisher_c_fast publisher_c_fast.cc)
  target_link_libraries(publisher_c_fast ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/subscriber_c.cc")
  add_executable(subscriber_c subscriber_c.cc)
  target_link_libraries(subscriber_c ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (NOT MSVC AND EXISTS "${CMAKE_SOURCE_DIR}/subscriber_c_slow.cc")
  add_executable(subscriber_c_slow subscriber_c_slow.cc)
  target_link_libraries(subscriber_c_slow ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/subscriber_stats.cc")
  add_executable(subscriber_stats subscriber_stats.cc)
  target_link_libraries(subscriber_stats ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/publisher.cc")
  add_executable(publisher publisher.cc)
  target_link_libraries(publisher ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/subscriber.cc")
  add_executable(subscriber subscriber.cc)
  target_link_libraries(subscriber ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/subscriber_generic.cc")
  add_executable(subscriber_generic subscriber_generic.cc)
  target_link_libraries(subscriber_generic
    ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/responser.cc")
  add_executable(responser responser.cc)
  target_link_libraries(responser ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/requester.cc")
  add_executable(requester requester.cc)
  target_link_libraries(requester ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/requester_async.cc")
  add_executable(requester_async requester_async.cc)
  target_link_libraries(requester_async
    ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/responser_oneway.cc")
  add_executable(responser_oneway responser_oneway.cc)
  target_link_libraries(responser_oneway
    ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/requester_oneway.cc")
  add_executable(requester_oneway requester_oneway.cc)
  target_link_libraries(requester_oneway
    ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/responser_no_input.cc")
  add_executable(responser_no_input responser_no_input.cc)
  target_link_libraries(responser_no_input
    ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/requester_no_input.cc")
  add_executable(requester_no_input requester_no_input.cc)
  target_link_libraries(requester_no_input
    ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/requester_async_no_input.cc")
  add_executable(requester_async_no_input requester_async_no_input.cc)
  target_link_libraries(requester_async_no_input
    ignition-transport${IGN_TRANSPORT_VER}::core)
endif()

# FIXME(chapulina) Linking failure on Windows:
# msgs\stringmsg.pb.cc : fatal error LNK1107: invalid or corrupt file: cannot read at 0x3028 
if (NOT MSVC AND TARGET protobuf_compilation AND
    EXISTS "${CMAKE_SOURCE_DIR}/publisher_custom_msg.cc")
  add_executable(publisher_custom_msg publisher_custom_msg.cc)
  target_link_libraries(publisher_custom_msg
    ignition-transport${IGN_TRANSPORT_VER}::core
    ${PROTO_SRC}
  )
  add_dependencies(publisher_custom_msg protobuf_compilation)
endif()

# FIXME(chapulina) Linking failure on Windows:
# msgs\stringmsg.pb.cc : fatal error LNK1107: invalid or corrupt file: cannot read at 0x3028 
if (NOT MSVC AND TARGET protobuf_compilation AND
    EXISTS "${CMAKE_SOURCE_DIR}/subscriber_custom_msg.cc")
  add_executable(subscriber_custom_msg subscriber_custom_msg.cc)
  target_link_libraries(subscriber_custom_msg
    ignition-transport${IGN_TRANSPORT_VER}::core
    ${PROTO_SRC}
  )
  add_dependencies(subscriber_custom_msg protobuf_compilation)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/publisher_raw.cc")
  add_executable(publisher_raw publisher_raw.cc)
  target_link_libraries(publisher_raw
    ignition-transport${IGN_TRANSPORT_VER}::core
  )
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/subscriber_raw.cc")
  add_executable(subscriber_raw subscriber_raw.cc)
  target_link_libraries(subscriber_raw
    ignition-transport${IGN_TRANSPORT_VER}::core
  )
endif()

# Logging examples.
if (TARGET ignition-transport${IGN_TRANSPORT_VER}::log)

  if (EXISTS "${CMAKE_SOURCE_DIR}/record.cc")
    add_executable(log_record record.cc)
    target_link_libraries(log_record
      ignition-transport${IGN_TRANSPORT_VER}::log
    )
  endif()

  if (EXISTS "${CMAKE_SOURCE_DIR}/playback.cc")
    add_executable(log_playback playback.cc)
    target_link_libraries(log_playback
      ignition-transport${IGN_TRANSPORT_VER}::log
    )
  endif()

  if (EXISTS "${CMAKE_SOURCE_DIR}/custom_query.cc")
    add_executable(log_custom_query custom_query.cc)
    target_link_libraries(log_custom_query
      ignition-transport${IGN_TRANSPORT_VER}::log
    )
  endif()

endif()


if (MSVC)
  # Suppress Protobuf message generation warnings.
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4018 /wd4100 /wd4127 /wd4244 /wd4267 /wd4512")

  # Suppress the "decorated name length exceed" warning (inside the STL).
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4503")

  add_definitions(-DBUILDING_STATIC_LIBS -DWIN32_LEAN_AND_MEAN)

  # Don't pull in the Windows min/max macros
  add_definitions(-DNOMINMAX)

endif()

=== debian/changelog ===
ignition-transport10 (10.1.0-2~buster) buster; urgency=medium

  * ignition-transport10 10.1.0-2 release

 -- Louise Poubel <louise@openrobotics.org>  Fri, 12 Nov 2021 11:10:50 -0800

ignition-transport10 (10.1.0-1~buster) buster; urgency=medium

  * ignition-transport10 10.1.0-1 release

 -- Carlos Aguero <caguero@openrobotics.org>  Mon, 18 Oct 2021 18:15:36 +0200

ignition-transport10 (10.0.1-1~buster) buster; urgency=medium

  * ignition-transport10 10.0.1-1 release

 -- Carlos Aguero <caguero@openrobotics.org>  Sun, 17 Oct 2021 23:07:15 +0200

ignition-transport10 (10.0.0-1~buster) buster; urgency=medium

  * ignition-transport10 10.0.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 31 Mar 2021 12:47:06 -0700

ignition-transport10 (10.0.0~pre2-2~buster) buster; urgency=medium

  * ignition-transport10 10.0.0~pre2-2 release

 -- Louise Poubel <louise@openrobotics.org>  Fri, 26 Mar 2021 12:31:10 -0700

ignition-transport10 (10.0.0~pre2-1~buster) buster; urgency=medium

  * ignition-transport10 10.0.0~pre2-1 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 25 Mar 2021 18:26:27 -0700

ignition-transport10 (10.0.0~pre1-2~buster) buster; urgency=medium

  * ignition-transport10 10.0.0~pre1-2 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 25 Mar 2021 18:17:49 -0700

ignition-transport10 (10.0.0~pre1-1~buster) buster; urgency=medium

  * ignition-transport10 10.0.0~pre1-1 release

 -- Carlos Aguero <caguero@openrobotics.org>  Thu, 25 Mar 2021 16:10:22 +0100

ignition-transport10 (9.999.999-1~buster) buster; urgency=medium

  * Stub to be removed after first entry

 -- Louise Poubel <louise@openrobotics.org>  Wed, 07 Oct 2020 17:36:55 -0700

=== debian/control ===
Source: ignition-transport10
Standards-Version: 3.9.4
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: extra
Build-Depends: cmake,
               pkg-config,
               debhelper (>= 11),
               doxygen,
               python3,
               ruby-ronn,
               libprotoc-dev,
               libprotobuf-dev,
               libignition-msgs7-dev,
               libignition-cmake2-dev,
               libignition-tools-dev,
               libignition-utils1-cli-dev,
               libignition-utils1-dev,
               protobuf-compiler,
               uuid-dev,
               libzmq3-dev (>= 3.0.0),
               libsqlite3-dev
Vcs-Browser: https://github.org/ignition-relase/ign-transport10-release
Vcs-Git: https://github.org/ignition-relase/ign-transport10-release
Homepage: https://github.com/ignition-release/ign-transport

Package: libignition-transport10-core-dev
Architecture: any
Section: libdevel
Depends: libignition-transport10 (= ${binary:Version}),
         uuid-dev,
         libzmq3-dev (>= 3.0.0),
         libignition-msgs7-dev,
         libignition-cmake2-dev,
         libignition-tools-dev,
         libignition-utils1-cli-dev,
         libignition-utils1-dev,
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Robotics transport Library - Core Dev files

Package: libignition-transport10
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Robotics Transport Library - Shared library

Package: libignition-transport10-log-dev
Architecture: any
Section: libdevel
Depends: libsqlite3-dev,
         libignition-cmake2-dev,
         libignition-transport10-core-dev (= ${binary:Version}),
         libignition-transport10-log (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Robotics transport Library - Core Dev

Package: libignition-transport10-log
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Robotics Transport Library - Log Shared library

Package: libignition-transport10-dev
Architecture: any
Section: libdevel
Depends: libignition-transport10-core-dev (= ${binary:Version}),
         libignition-transport10-log-dev (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Robotics transport Library - Metapackage

Package: libignition-transport10-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
     libignition-transport10 (= ${binary:Version}),
     ${misc:Depends}
Multi-Arch: same
Description: Ignition Robotics transport Library - Debugging symbols

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),amd64 i386))
  CMAKE_HOST_CFLAGS="True"
else
  CMAKE_HOST_CFLAGS="False"
endif

.PHONY: override_dh_auto_configure \
        override_dh_install \
        override_dh_auto_test \
	override_dh_strip

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
            -DUSE_HOST_CFLAGS:BOOL=${CMAKE_HOST_CFLAGS} \
	    -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_install:
	dh_install --
	# need to remove files present in components
	$(RM) debian/libignition-transport*-core-dev/usr/include/ignition/transport*/ignition/transport/log.hh
	dh_missing --list-missing

# Test can not run in parallel
override_dh_auto_test:
	# Fix tests. They need special configuration for networking
	# dh_auto_test --max-parallel=1
	true

override_dh_strip:
	dh_strip -a --dbg-package=libignition-transport10-dbg

## ignition-transport10 10.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-transport10 VERSION 10.1.0)
+project(ignition-transport10 VERSION 10.2.0)
 
 #============================================================================
 # Find ignition-cmake

=== debian/changelog ===
ignition-transport10 (10.2.0-1~revyos1) bullseye; urgency=medium

  * Release for RevyOS riscv64
  * http://packages.ros.org/ros2/ubuntu/pool/main/i/ignition-transport10/

 -- CHEN Xuan <chenxuan@iscas.ac.cn>  Mon, 27 May 2024 09:40:43 +0800

ignition-transport10 (10.2.0-1~focal) focal; urgency=medium

  * ignition-transport10 10.2.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Fri, 25 Mar 2022 09:02:28 -0700

ignition-transport10 (10.1.0-2~focal) focal; urgency=medium

  * ignition-transport10 10.1.0-2 release

 -- Louise Poubel <louise@openrobotics.org>  Fri, 12 Nov 2021 11:10:50 -0800

ignition-transport10 (10.1.0-1~focal) focal; urgency=medium

  * ignition-transport10 10.1.0-1 release

 -- Carlos Aguero <caguero@openrobotics.org>  Mon, 18 Oct 2021 18:15:36 +0200

ignition-transport10 (10.0.1-1~focal) focal; urgency=medium

  * ignition-transport10 10.0.1-1 release

 -- Carlos Aguero <caguero@openrobotics.org>  Sun, 17 Oct 2021 23:07:14 +0200

ignition-transport10 (10.0.0-1~focal) focal; urgency=medium

  * ignition-transport10 10.0.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 31 Mar 2021 12:47:06 -0700

ignition-transport10 (10.0.0~pre2-2~focal) focal; urgency=medium

  * ignition-transport10 10.0.0~pre2-2 release

 -- Louise Poubel <louise@openrobotics.org>  Fri, 26 Mar 2021 12:31:10 -0700

ignition-transport10 (10.0.0~pre2-1~focal) focal; urgency=medium

  * ignition-transport10 10.0.0~pre2-1 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 25 Mar 2021 18:26:27 -0700

ignition-transport10 (10.0.0~pre1-2~focal) focal; urgency=medium

  * ignition-transport10 10.0.0~pre1-2 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 25 Mar 2021 18:17:49 -0700

ignition-transport10 (10.0.0~pre1-1~focal) focal; urgency=medium

  * ignition-transport10 10.0.0~pre1-1 release

 -- Carlos Aguero <caguero@openrobotics.org>  Thu, 25 Mar 2021 16:10:22 +0100

ignition-transport10 (9.999.999-1~focal) focal; urgency=medium

  * Stub to be removed after first entry

 -- Louise Poubel <louise@openrobotics.org>  Wed, 07 Oct 2020 17:36:55 -0700

=== debian/control ===
--- 
+++ 
@@ -12,13 +12,13 @@
                libprotoc-dev,
                libprotobuf-dev,
                libignition-msgs7-dev,
-               libignition-cmake2-dev,
+               libignition-cmake-dev,
                libignition-tools-dev,
-               libignition-utils1-cli-dev,
-               libignition-utils1-dev,
+               libignition-utils-dev,
                protobuf-compiler,
                uuid-dev,
                libzmq3-dev (>= 3.0.0),
+               cppzmq-dev,
                libsqlite3-dev
 Vcs-Browser: https://github.org/ignition-relase/ign-transport10-release
 Vcs-Git: https://github.org/ignition-relase/ign-transport10-release
@@ -30,11 +30,11 @@
 Depends: libignition-transport10 (= ${binary:Version}),
          uuid-dev,
          libzmq3-dev (>= 3.0.0),
+         cppzmq-dev,
          libignition-msgs7-dev,
-         libignition-cmake2-dev,
+         libignition-cmake-dev,
          libignition-tools-dev,
-         libignition-utils1-cli-dev,
-         libignition-utils1-dev,
+         libignition-utils-dev,
          ${misc:Depends}
 Multi-Arch: same
 Description: Ignition Robotics transport Library - Core Dev files
@@ -51,7 +51,7 @@
 Architecture: any
 Section: libdevel
 Depends: libsqlite3-dev,
-         libignition-cmake2-dev,
+         libignition-cmake-dev,
          libignition-transport10-core-dev (= ${binary:Version}),
          libignition-transport10-log (= ${binary:Version}),
          ${misc:Depends}
